package com.megabras.bluelogg;


import android.app.Activity;
import android.view.Menu;
import android.view.View;
import android.widget.FrameLayout;
import android.widget.LinearLayout;

import com.megabras.modbus.Message;

public abstract class Controller
{
    public static final int OVERLAY_ID = R.id.overlay;

    public abstract void createSwipe();

    public abstract void createControlButtons( LinearLayout container );

    public abstract void setToolBarId( int toolBarId );

    public abstract void stateChanged( int state );

    public abstract void processResponse( int id, String response );

    public abstract void sendMessage( Message message );

    public abstract Message statusMessage();

    public abstract void readGeneralConfig();

    public abstract void setAutoConn( boolean enable );

    public abstract void setDateTimeFormat( int dateFormat, int timeFormat );

    public abstract void setMenuItemOptions( Menu menu, int optionsID );

    public abstract boolean getAutoConn();

    public abstract void onClose();

    public abstract void permissionCallback( int permission );

    public void closeOverlay( Activity activity )
    {
        FrameLayout overlay = activity.findViewById( OVERLAY_ID );
        overlay.removeAllViews();
        overlay.setVisibility( View.GONE );
    }
}
