package com.megabras.bluelogg.MPKXX5R;

import android.content.Context;
import android.content.res.Configuration;
import android.graphics.drawable.Drawable;
import android.text.Spannable;
import android.text.SpannableString;
import android.text.style.ImageSpan;

import com.megabras.bluelogg.R;

import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentStatePagerAdapter;

public class PagerAdapter extends FragmentStatePagerAdapter
{
    @SuppressWarnings("unused")
    private final
            String TAG = "MPKXX5R.PagerAdapter";

    private Context
            context;

    @SuppressWarnings("FieldCanBeLocal")
    private final int
            numPages = 2;

    private MainFragment
            mainFragment;

    private ChartFragment
            table;

    private int[]
            imageResId =
            {
                R.drawable.ic_analog,
                R.drawable.ic_table
            },
            imageResIdSmall =
            {
                R.drawable.ic_analog_20,
                R.drawable.ic_table_20
            };

    public PagerAdapter(FragmentManager fm, Context context)
    {
        super(fm);
        this.context = context;
        mainFragment = new MainFragment();
        table        = new ChartFragment();
    }

    @Override
    public Fragment getItem(int i)
    {
        switch (i)
        {
            case 0:
                return mainFragment;
            case 1:
                return table;
        }
        return null;
    }

    @Override
    public int getCount()
    {
        return numPages;
    }

    MainFragment getMainFragment()
    {
        return mainFragment;
    }

    ChartFragment table()
    {
        return table;
    }

    @Override
    public CharSequence getPageTitle( int position )
    {
        int[] images;
        if ( screenSizeIsLarge( context ) )
        {
            images = imageResId;
        }
        else
        {
            images = imageResIdSmall;
        }
        Drawable        image     = context.getResources().getDrawable( images[position] );
        image.setBounds( 0, 0, image.getIntrinsicWidth(), image.getIntrinsicHeight() );
        SpannableString sb        = new SpannableString( " " );
        ImageSpan       imageSpan = new ImageSpan( image, ImageSpan.ALIGN_BOTTOM );
        sb.setSpan( imageSpan, 0, 1, Spannable.SPAN_EXCLUSIVE_EXCLUSIVE );
        return sb;
    }

    private boolean screenSizeIsLarge( Context context )
    {
        return (context.getResources().getConfiguration().screenLayout &
                Configuration.SCREENLAYOUT_SIZE_MASK) == Configuration.SCREENLAYOUT_SIZE_LARGE;
    }
}



