package com.megabras.bluelogg.extended;

import android.annotation.SuppressLint;
import android.app.Activity;
import android.app.Dialog;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.text.InputFilter;
import android.view.View;
import android.view.Window;
import android.view.WindowManager;
import android.widget.Button;
import android.widget.EditText;
import android.widget.ImageButton;
import android.widget.ImageView;
import android.widget.Spinner;
import android.widget.TextView;

import com.megabras.bluelogg.R;
import com.megabras.modbus.NumberParser;

import org.w3c.dom.Text;

import androidx.annotation.NonNull;
import androidx.viewpager.widget.ViewPager;

@SuppressWarnings({"WeakerAccess", "unused"})
public class Dialogs
{

    private final Activity
            activity;

    private DialogsInterface
            dlgInterface;

    private Dialog
            dlg_finished,
            ui_dlg_progress;

    private ImageView
            dlg_finished_ico_warning;

    private TextView
            dlg_finished_txw_observation,
            dlg_finished_txw_message;

    private Button
            dlg_finished_btn_close;

    public Dialogs( Activity activity, DialogsInterface dlgInterface )
    {
        this.activity = activity;
        this.dlgInterface = dlgInterface;
    }

    @SuppressLint("SetTextI18n")
    public void pickNumber( int id, int value, String unit, int min, int max, int step )
    {
        final Dialog dialog = new Dialog( activity );
        dialog.requestWindowFeature( Window.FEATURE_NO_TITLE );
        dialog.setCanceledOnTouchOutside( false );
        dialog.setContentView( R.layout.main_dialog_number );
//        if ( dialog.getWindow() != null )
//        {
//            dialog.getWindow().getAttributes().width = WindowManager.LayoutParams.MATCH_PARENT;
//        }

        final TextView ui_txw_title = dialog.findViewById( R.id.tv_message );
        final EditText ui_edt_number = dialog.findViewById( R.id.et_number );
        final TextView ui_txw_tips = dialog.findViewById( R.id.tv_tips );
        final TextView ui_txw_warning = dialog.findViewById( R.id.tv_warning );
        ((TextView)dialog.findViewById( R.id.tv_unit )).setText( unit );

        ui_txw_title.setText( activity.getString( R.string.enter_number ) );
        ui_edt_number.setText( value + "" );
        ui_txw_warning.setText( activity.getString( R.string.generic_range_with_steps, min + " " + unit, max + " " + unit, step + " " + unit ) );

        dialog.findViewById( R.id.bt_save ).setOnClickListener( v ->
        {
            if ( ui_edt_number.getText().toString().equals( "" ) )
                return;

            int newVoltage = NumberParser.parseInt( ui_edt_number.getText().toString() );

            if ( newVoltage >= min && newVoltage <= max && newVoltage % step == 0 )
            {
                dlgInterface.dialogsResponse( id, newVoltage );
                dialog.dismiss();
            }
            else
            {
                ui_txw_warning.setTextColor( activity.getResources().getColor( R.color.common_signin_btn_default_background ) );
                if ( max > min )
                {
                    int low = newVoltage - (newVoltage % step);
                    if ( low >= max )
                    {
                        low = max - step;
                    }
                    else if ( low < min )
                    {
                        low = min;
                    }
                    int high = low + step;

                    ui_txw_tips.setVisibility( View.VISIBLE );
                    ui_txw_tips.setText( activity.getString( R.string.did_you_mean_x_or_y, low + " " + unit, high + " " + unit ) );
                }
            }
        } );

        dialog.findViewById( R.id.bt_cancel ).setOnClickListener( v -> dialog.dismiss() );

        dialog.show();
    }

    @SuppressWarnings("WeakerAccess")
    @SuppressLint("SetTextI18n")
    public void pickNumber( TextView txw, int min, int max, int step )
    {
        final Dialog dialog = new Dialog( activity );
        dialog.requestWindowFeature( Window.FEATURE_NO_TITLE );
        dialog.setCanceledOnTouchOutside( false );
        dialog.setContentView( R.layout.main_dialog_number );
//        if ( dialog.getWindow() != null )
//        {
//            dialog.getWindow().getAttributes().width = WindowManager.LayoutParams.MATCH_PARENT;
//        }

        final TextView ui_txw_title = dialog.findViewById( R.id.tv_message );
        final EditText ui_edt_number = dialog.findViewById( R.id.et_number );
        final TextView ui_txw_tips = dialog.findViewById( R.id.tv_tips );
        final TextView ui_txw_warning = dialog.findViewById( R.id.tv_warning );

        String unit = NumberParser.parseIntUnity( txw.getText().toString() );
        int value = NumberParser.parseInt( txw.getText().toString() );
        ((TextView)dialog.findViewById( R.id.tv_unit )).setText( unit );

        ui_txw_title.setText( activity.getString( R.string.enter_number ) );
        ui_edt_number.setText( value + "" );
        ui_txw_warning.setText( activity.getString( R.string.generic_range_with_steps, min + " " + unit, max + " " + unit, step + " " + unit ) );

        dialog.findViewById( R.id.bt_save ).setOnClickListener( v ->
        {
            if ( ui_edt_number.getText().toString().equals( "" ) )
                return;

            int newVoltage = NumberParser.parseInt( ui_edt_number.getText().toString() );

            if ( newVoltage >= min && newVoltage <= max && newVoltage % step == 0 )
            {
                txw.setText( newVoltage + " " + unit );
                dialog.dismiss();
            }
            else
            {
                ui_txw_warning.setTextColor( activity.getResources().getColor( R.color.common_signin_btn_default_background ) );
                if ( max > min )
                {
                    int low = newVoltage - (newVoltage % step);
                    if ( low >= max )
                    {
                        low = max - step;
                    }
                    else if ( low < min )
                    {
                        low = min;
                    }
                    int high = low + step;

                    ui_txw_tips.setVisibility( View.VISIBLE );
                    ui_txw_tips.setText( activity.getString( R.string.did_you_mean_x_or_y, low + " " + unit, high + " " + unit ) );
                }
            }
        } );

        dialog.findViewById( R.id.bt_cancel ).setOnClickListener( v -> dialog.dismiss() );

        dialog.show();
    }

    @SuppressWarnings("WeakerAccess")
    @SuppressLint("SetTextI18n")
    public void pickNumber( TextView txw, int min, TextView txwMax, int step, float factor )
    {
        final Dialog dialog = new Dialog( activity );
        dialog.requestWindowFeature( Window.FEATURE_NO_TITLE );
        dialog.setCanceledOnTouchOutside( false );
        dialog.setContentView( R.layout.main_dialog_number );
//        if ( dialog.getWindow() != null )
//        {
//            dialog.getWindow().getAttributes().width = WindowManager.LayoutParams.MATCH_PARENT;
//        }

        int maxFoo    = (int) ( NumberParser.parseInt( txwMax.getText().toString() ) * factor );
        final int max = ( maxFoo / step ) * step;

        final TextView ui_txw_title = dialog.findViewById( R.id.tv_message );
        final EditText ui_edt_number = dialog.findViewById( R.id.et_number );
        final TextView ui_txw_tips = dialog.findViewById( R.id.tv_tips );
        final TextView ui_txw_warning = dialog.findViewById( R.id.tv_warning );

        String unit = NumberParser.parseIntUnity( txw.getText().toString() );
        int value = NumberParser.parseInt( txw.getText().toString() );
        ((TextView)dialog.findViewById( R.id.tv_unit )).setText( unit );

        ui_txw_title.setText( activity.getString( R.string.enter_number ) );
        ui_edt_number.setText( value + "" );
        ui_txw_warning.setText( activity.getString( R.string.generic_range_with_steps, min + " " + unit, max + " " + unit, step + " " + unit ) );

        dialog.findViewById( R.id.bt_save ).setOnClickListener( v ->
        {
            if ( ui_edt_number.getText().toString().equals( "" ) )
                return;

            int newVoltage = NumberParser.parseInt( ui_edt_number.getText().toString() );

            if ( newVoltage >= min && newVoltage <= max && newVoltage % step == 0 )
            {
                txw.setText( newVoltage + " " + unit );
                dialog.dismiss();
            }
            else
            {
                ui_txw_warning.setTextColor( activity.getResources().getColor( R.color.common_signin_btn_default_background ) );
                if ( max > min )
                {
                    int low = newVoltage - (newVoltage % step);
                    if ( low >= max )
                    {
                        low = max - step;
                    }
                    else if ( low < min )
                    {
                        low = min;
                    }
                    int high = low + step;

                    ui_txw_tips.setVisibility( View.VISIBLE );
                    ui_txw_tips.setText( activity.getString( R.string.did_you_mean_x_or_y, low + " " + unit, high + " " + unit ) );
                }
            }
        } );

        dialog.findViewById( R.id.bt_cancel ).setOnClickListener( v -> dialog.dismiss() );

        dialog.show();
    }

    @SuppressWarnings("WeakerAccess")
    @SuppressLint("SetTextI18n")
    public void pickNumber( TextView txw, TextView txwValidate, int min, int max, int step, float factor )
    {
        final Dialog dialog = new Dialog( activity );
        dialog.requestWindowFeature( Window.FEATURE_NO_TITLE );
        dialog.setCanceledOnTouchOutside( false );
        dialog.setContentView( R.layout.main_dialog_number );
//        if ( dialog.getWindow() != null )
//        {
//            dialog.getWindow().getAttributes().width = WindowManager.LayoutParams.MATCH_PARENT;
//        }

        final TextView ui_txw_title = dialog.findViewById( R.id.tv_message );
        final EditText ui_edt_number = dialog.findViewById( R.id.et_number );
        final TextView ui_txw_tips = dialog.findViewById( R.id.tv_tips );
        final TextView ui_txw_warning = dialog.findViewById( R.id.tv_warning );

        String unit = NumberParser.parseIntUnity( txw.getText().toString() );
        int value = NumberParser.parseInt( txw.getText().toString() );
        ((TextView)dialog.findViewById( R.id.tv_unit )).setText( unit );

        ui_txw_title.setText( activity.getString( R.string.enter_number ) );
        ui_edt_number.setText( value + "" );
        ui_txw_warning.setText( activity.getString( R.string.generic_range_with_steps, min + " " + unit, max + " " + unit, step + " " + unit ) );

        dialog.findViewById( R.id.bt_save ).setOnClickListener( v ->
        {
            if ( ui_edt_number.getText().toString().equals( "" ) )
                return;

            int newVoltage = NumberParser.parseInt( ui_edt_number.getText().toString() );

            if ( newVoltage >= min && newVoltage <= max && newVoltage % step == 0 )
            {
                txw.setText( newVoltage + " " + unit );

                int toValidate = NumberParser.parseInt( txwValidate.getText().toString() );
                if ( toValidate > (int)( newVoltage * factor  ) )
                {
                    toValidate = (int)( newVoltage * factor );
                    toValidate = ( toValidate / step ) * step;
                    txwValidate.setText( toValidate + " " + unit );
                }
                dialog.dismiss();
            }
            else
            {
                ui_txw_warning.setTextColor( activity.getResources().getColor( R.color.common_signin_btn_default_background ) );
                if ( max > min )
                {
                    int low = newVoltage - (newVoltage % step);
                    if ( low >= max )
                    {
                        low = max - step;
                    }
                    else if ( low < min )
                    {
                        low = min;
                    }
                    int high = low + step;

                    ui_txw_tips.setVisibility( View.VISIBLE );
                    ui_txw_tips.setText( activity.getString( R.string.did_you_mean_x_or_y, low + " " + unit, high + " " + unit ) );
                }
            }
        } );

        dialog.findViewById( R.id.bt_cancel ).setOnClickListener( v -> dialog.dismiss() );

        dialog.show();
    }

    public void btnNumberPicker( Button btn, TextView txw, int min, int max, int step )
    {
        btn.setOnClickListener( view -> pickNumber( txw, min, max, step ) );
    }

    public void btnNumberPicker( ImageButton btn, TextView txw, int min, int max, int step )
    {
        btn.setOnClickListener( view -> pickNumber( txw, min, max, step ) );
    }

    public void btnNumberPicker( ImageButton btn, TextView txw, TextView txwValidate, int min, int max, int step, float factor )
    {
        btn.setOnClickListener( view -> pickNumber( txw, txwValidate, min, max, step, factor ) );
    }

    public void btnNumberPicker( ImageButton btn, TextView txw, int min, TextView txwMax, int step, float factor )
    {
        btn.setOnClickListener( view -> pickNumber( txw, min, txwMax, step, factor ) );
    }

    @SuppressLint("SetTextI18n")
    public void pickOhm( final TextView txw, double min, double max )
    {
        final Dialog dialog = new Dialog( activity );
        dialog.requestWindowFeature( Window.FEATURE_NO_TITLE );
        dialog.setCanceledOnTouchOutside( false );
        dialog.setContentView( R.layout.main_dialog_number_unity_selector );
//        if ( dialog.getWindow() != null )
//        {
//            dialog.getWindow().getAttributes().width = WindowManager.LayoutParams.MATCH_PARENT;
//        }

        final EditText ui_edt_number = dialog.findViewById( R.id.et_number );
        final TextView ui_txw_title   = dialog.findViewById( R.id.tv_message );
        final TextView ui_txw_warning = dialog.findViewById( R.id.tv_warning );

        ui_txw_title.setText( activity.getString( R.string.minimum_resistance ) );

        String unit = NumberParser.parseIntUnity( txw.getText().toString() );

        ui_txw_warning.setText( activity.getString( R.string.ohm_range, NumberParser.getOhmFormattedString( (long) min ), NumberParser.getOhmFormattedString( (long) max ) ) );
        ui_txw_warning.setVisibility( View.VISIBLE );

        final Spinner ui_spn_unity = dialog.findViewById( R.id.spManualLimUnity );

        if ( unit.contains( "T" ) )
        {
            ui_spn_unity.setSelection( 3 ); // 1000^( 3 + 1 ) = 1.000.000.000.000
        }
        else if ( unit.contains( "G" ) )
        {
            ui_spn_unity.setSelection( 2 ); // 1000^( 2 + 1 ) = 1.000.000.000
        }
        else if ( unit.contains( "M" ) )
        {
            ui_spn_unity.setSelection( 1 ); // 1000^( 1 + 1 ) = 1.000.000
        }
        else
        {
            ui_spn_unity.setSelection( 0 ); // 1000^( 0 + 1 ) = 1.000
        }

        int value = NumberParser.parseInt( txw.getText().toString() );
        ui_edt_number.setText( value + "" );

        dialog.findViewById( R.id.bt_save ).setOnClickListener( v ->
        {
            String val = ui_edt_number.getText().toString();

            if ( val.equals( "" ) || val.contains( "." ) || val.contains( "," ) )
                return;

            long newValue = Integer.parseInt( val );
            int exp = ui_spn_unity.getSelectedItemPosition() + 1;
            newValue = (long) (newValue * Math.pow( 1000, exp ));

            if ( newValue >= min && newValue <= max )
            {
                txw.setText( NumberParser.getOhmFormattedString( newValue ) );
                dialog.dismiss();
            }
            else
            {
                ui_txw_warning.setTextColor( activity.getResources().getColor( R.color.common_signin_btn_default_background ) );
            }
        } );

        dialog.findViewById( R.id.bt_cancel ).setOnClickListener( v -> dialog.dismiss() );

        dialog.show();
    }

    public void btnOhmPicker( ImageButton btn, TextView txw, double min, double max )
    {
        btn.setOnClickListener( view -> pickOhm( txw, min, max ) );
    }

    @SuppressLint("SetTextI18n")
    public void pickTimer( final TextView txw, int min, int max )
    {
        final Dialog dialog = new Dialog( activity );
        dialog.requestWindowFeature( Window.FEATURE_NO_TITLE );
        dialog.setCanceledOnTouchOutside( false );
        dialog.setContentView( R.layout.main_dialog_timer );
        if ( dialog.getWindow() != null )
        {
            dialog.getWindow().getAttributes().width = WindowManager.LayoutParams.MATCH_PARENT;
        }

        final EditText ui_edt_mm      = dialog.findViewById( R.id.et_number_mm );
        final EditText ui_edt_ss      = dialog.findViewById( R.id.et_number_ss );
        final TextView ui_txw_title   = dialog.findViewById( R.id.tv_message );
        final TextView ui_txw_warning = dialog.findViewById( R.id.tv_warning );

        ui_txw_title.setText( activity.getString( R.string.test_duration ) );

        ui_edt_mm.setFilters( new InputFilter[]{new InputFilterMinMax( min/60, max/60 )} );
        ui_edt_ss.setFilters( new InputFilter[]{new InputFilterMinMax( 0, 59 )} );

        ui_txw_warning.setText( activity.getString( R.string.ohm_range, min / 60 + " min", max / 60 + " min" ) );

        ui_edt_mm.setText( NumberParser.parseTimeMin( txw.getText().toString() ) + "" );
        ui_edt_ss.setText( NumberParser.parseTimeSec( txw.getText().toString() ) + "" );

        dialog.findViewById( R.id.bt_save ).setOnClickListener(v ->
        {
            if( ui_edt_mm.getText().toString().equals("") || ui_edt_ss.getText().toString().equals("") )
                return;

            String fooMin = ui_edt_mm.getText().toString();
            fooMin = fooMin.trim();
            String fooSec = ui_edt_ss.getText().toString();
            fooSec = fooSec.trim();

            int value = ( Integer.parseInt( fooMin ) * 60 ) + Integer.parseInt( fooSec );

            if ( value >= min && value <= max )
            {
                txw.setText( NumberParser.getTimeFormattedString( value ) );
                dialog.dismiss();
            }
            else
            {
                ui_txw_warning.setTextColor( activity.getResources().getColor( R.color.common_signin_btn_default_background ) );
            }
        });

        dialog.findViewById( R.id.bt_cancel ).setOnClickListener( v -> dialog.dismiss() );

        dialog.show();
    }

    public void btnTimerPicker( ImageButton btn, TextView txw, int min, int max )
    {
        btn.setOnClickListener( view -> pickTimer( txw, min, max ) );
    }

    public void startTest( View.OnClickListener onClick )
    {
        Dialog dlg = new Dialog( activity );
        dlg.requestWindowFeature( Window.FEATURE_NO_TITLE );
        dlg.setCanceledOnTouchOutside( false );
        dlg.setContentView( R.layout.dialog_yes_no_white );
        if ( dlg.getWindow() != null )
        {
            dlg.getWindow().getAttributes().width = ViewPager.LayoutParams.MATCH_PARENT;
        }
        ((TextView) dlg.findViewById( R.id.dlg_title )).setText( R.string.md_warning_test_start );
        ((ImageView) dlg.findViewById( R.id.dlg_icon )).setImageResource( R.drawable.ic_warning );
        ((TextView) dlg.findViewById( R.id.message )).setText( activity.getResources().getString( R.string.want_start_test ).toUpperCase() );

        final Button ui_btn_dlg_no = dlg.findViewById( R.id.btn_no );
        ui_btn_dlg_no.setOnClickListener( v ->  dlg.dismiss() );

        final Button ui_btn_dlg_yes = dlg.findViewById( R.id.btn_yes );

        ui_btn_dlg_yes.setOnClickListener( v ->
        {
            onClick.onClick( v );
            dlg.dismiss();
        } );

        dlg.show();
    }

    private void createDialogFinished()
    {
        if ( dlg_finished == null )
        {
            dlg_finished = new Dialog( activity );
            dlg_finished.requestWindowFeature( Window.FEATURE_NO_TITLE );
            dlg_finished.setCanceledOnTouchOutside( false );
            dlg_finished.setCancelable( false );
            dlg_finished.setContentView( R.layout.dialog_message_white );
            if ( dlg_finished.getWindow() != null )
            {
                dlg_finished.getWindow().setBackgroundDrawable( new ColorDrawable( Color.TRANSPARENT ) );
            }
            ((ImageView) dlg_finished.findViewById( R.id.dlg_icon )).setImageResource( R.drawable.ic_warning );
            ((TextView) dlg_finished.findViewById( R.id.dlg_title )).setText( R.string.md_test_finished );

            dlg_finished_ico_warning = dlg_finished.findViewById( R.id.ui_iv_warning );
            dlg_finished_txw_observation = dlg_finished.findViewById( R.id.observation );
            dlg_finished_txw_message = dlg_finished.findViewById( R.id.message );
            dlg_finished_btn_close = dlg_finished.findViewById( R.id.btn_yes );
            dlg_finished.findViewById( R.id.btn_close_dlg ).setVisibility( View.GONE );

            dlg_finished_txw_observation.setText( "" );
            dlg_finished_ico_warning.setVisibility( View.GONE );
            dlg_finished_btn_close.setOnClickListener( v -> dlg_finished.dismiss() );
        }

        if ( !dlg_finished.isShowing() )
        {
            dlg_finished.show();
        }
    }

    @SuppressWarnings("StringConcatenationInLoop")
    public void finishedTest( boolean waiting, @NonNull String observation, String ... message )
    {
        createDialogFinished();
        if ( message != null && message.length > 0 )
        {
            String acumulator = "";
            for ( String msg : message )
            {
                acumulator += msg + "\r\n";
            }
            try
            {
                acumulator = acumulator.substring( 0, acumulator.length() - 2 ); // Removing the last New line
            }
            catch ( Exception ignored )
            {
            }
            dlg_finished_txw_message.setText( acumulator );
        }
        dlg_finished_txw_observation.setText( observation );
        dlg_finished_ico_warning.setVisibility( waiting ? View.VISIBLE : View.INVISIBLE );
        dlg_finished_btn_close.setText( waiting ? R.string.wait : R.string.ok );
    }

    public void showProgress( boolean show )
    {
        if ( ui_dlg_progress == null )
        {
            ui_dlg_progress = new Dialog( activity );
            ui_dlg_progress.requestWindowFeature( Window.FEATURE_NO_TITLE );
            ui_dlg_progress.setCanceledOnTouchOutside( false );
            ui_dlg_progress.setContentView( R.layout.progress_bar );
            ((TextView) ui_dlg_progress.findViewById( R.id.dlg_title )).setText( R.string.please_wait );
            ((TextView) ui_dlg_progress.findViewById( R.id.message )).setText( R.string.saving_data_in_pdf );
            ui_dlg_progress.findViewById( R.id.dlg_icon ).setVisibility( View.GONE );
        }
        if ( show )
        {
            ui_dlg_progress.show();
        }
        else
        {
            ui_dlg_progress.dismiss();
        }
    }

    public void updateProgressBar( String progress )
    {
        ((TextView) ui_dlg_progress.findViewById( R.id.status )).setText( progress );
    }

    public void autoPilot()
    {

        Dialog dlg = new Dialog( activity );
        dlg.requestWindowFeature( Window.FEATURE_NO_TITLE );
        dlg.setCanceledOnTouchOutside( false );
        dlg.setContentView( R.layout.dialog_yes_no_white );
        if ( dlg.getWindow() != null ) dlg.getWindow().getAttributes().width = ViewPager.LayoutParams.MATCH_PARENT;
        ((TextView) dlg.findViewById( R.id.dlg_title )).setText( R.string.md_remote_control_locked );
        ((ImageView) dlg.findViewById( R.id.dlg_icon )).setImageResource( R.drawable.ic_warning );
        ((TextView) dlg.findViewById( R.id.message )).setText( activity.getResources().getString( R.string.md_remote_control_locked_explained ) );

        final Button ui_btn_dlg_no = dlg.findViewById( R.id.btn_no );
        ui_btn_dlg_no.setVisibility( View.GONE );

        final Button ui_btn_dlg_yes = dlg.findViewById( R.id.btn_yes );
        ui_btn_dlg_yes.setText( R.string.ok );
        ui_btn_dlg_yes.setOnClickListener( v -> dlg.dismiss() );


        dlg.show();
    }
}
