package com.megabras.bluelogg.extended;

import java.util.Observable;

public class IntegerObservable extends Observable
    {
        public final int ID;
        private int value;

        public IntegerObservable(int id)
        {
            this.ID = id;
        }

        public IntegerObservable(int id, int value)
        {
            this.ID = id;
            this.value = value;
        }

        public void set(int value)
        {
            if ( this.value!=value )
            {
                this.value = value;
                setChanged();
                notifyObservers();
            }
        }

        public void set(Enum value)
        {
            if ( this.value!=value.ordinal() )
            {
                this.value = value.ordinal();
                setChanged();
                notifyObservers();
            }
        }

        public void update(int value)
        {
            this.value = value;
            setChanged();
            notifyObservers();
        }

        public int get()
        {
            return this.value;
        }
    }
