package com.megabras.bluelogg.extended;

import android.app.Activity;
import android.app.Dialog;
import android.content.DialogInterface;
import android.content.Intent;
import android.graphics.Color;
import android.graphics.drawable.ColorDrawable;
import android.view.View;
import android.view.Window;
import android.widget.AbsListView;
import android.widget.AdapterView;
import android.widget.AdapterView.OnItemClickListener;
import android.widget.Button;
import android.widget.ImageView;
import android.widget.ListView;
import android.widget.TextView;

import com.megabras.bluelogg.Main;
import com.megabras.bluelogg.R;
import com.megabras.bluelogg.bluetooth.ListDevices;
import com.megabras.bluelogg.bluetooth.MBluetoothDevice;
import com.megabras.bluelogg.em4058.EM4058;

import java.util.List;

public class MDialog {
	
	public static Dialog BluetoothAdapterNotFound(final Activity activity)
	{
		final Dialog dialog = getDialog(activity, R.layout.dialog_yes_no, R.drawable.ic_bluetooth_error, R.string.bluetooth_not_found);
		
		((TextView) dialog.findViewById(R.id.message)).setText(R.string.bluetooth_not_found_dlg);
		((Button) dialog.findViewById(R.id.btn_no)).setVisibility(View.GONE);
		
		Button ok = (Button) dialog.findViewById(R.id.btn_yes);
		ok.setText(R.string.ok);
		ok.setOnClickListener(new View.OnClickListener(){
			public void onClick(View v){
				dialog.dismiss();
				activity.finish();
			}
		});			
		
		return dialog;
	}
	
	public static Dialog NoPairedDevices(final Activity activity){
		final Dialog dialog = getDialog(activity, R.layout.dialog_yes_no, R.drawable.ic_no_device, R.string.no_devices);
		
		((TextView) dialog.findViewById(R.id.message)).setText(R.string.pair_and_try);
		
		Button pair = (Button) dialog.findViewById(R.id.btn_yes);
		pair.setText(R.string.bluetooth_config);
		pair.setOnClickListener(new View.OnClickListener(){
			public void onClick(View v){
				dialog.dismiss();
				Intent settingsIntent = new Intent( android.provider.Settings.ACTION_BLUETOOTH_SETTINGS );
				activity.startActivity(settingsIntent);
				activity.finish();
			}
		});
		
		Button cancel = (Button) dialog.findViewById(R.id.btn_no);
		cancel.setText(R.string.cancel);
		cancel.setOnClickListener(new View.OnClickListener(){
			public void onClick(View v){
				dialog.dismiss();
				activity.finish();
			}
		});
		
		return dialog;
	}
	
//	public static Dialog PairedDevices(final Activity activity, final List<MBluetoothDevice> devices){
//		//try{
//			final Dialog dialog = getDialog(activity, R.layout.dialog_equipment, R.drawable.ic_device, R.string.devices);
//			final ListDevices adapter = new ListDevices(activity, devices);
//
//			ListView listDevice = (ListView) dialog.findViewById(R.id.list);
//			listDevice.setChoiceMode(AbsListView.CHOICE_MODE_SINGLE);
//			listDevice.setAdapter(adapter);
//
//			listDevice.setOnItemClickListener(new OnItemClickListener() {
//	            public void onItemClick(AdapterView<?> parent, View view, int position, long id) {
//					devices.get(position).startActivity(true);
//					dialog.dismiss();
//					activity.finish();
//	            }
//	        });
//
//			Button cancel = (Button) dialog.findViewById(R.id.btn_cancel);
//			cancel.setOnClickListener(new View.OnClickListener(){
//				public void onClick(View v){
//					dialog.dismiss();
//					activity.finish();
//				}
//			});
//
//			dialog.setOnCancelListener(new DialogInterface.OnCancelListener() {  // OnBackPressed
//	            public void onCancel(DialogInterface dialog) {
//	            	activity.finish();
//	            }
//	        });
//
//			return dialog;
////		} catch (Exception e){
////			e.printStackTrace();
////			return null;
////		}
//	}



	public static Dialog ExitApplication(final Main activity){
		final Dialog dialog = new Dialog(activity);
		dialog.requestWindowFeature(Window.FEATURE_NO_TITLE);
		dialog.setCanceledOnTouchOutside(false);
		dialog.setContentView(R.layout.dialog_yes_no);
		dialog.getWindow().getAttributes().width = android.view.ViewGroup.LayoutParams.MATCH_PARENT;
		((TextView) dialog.findViewById(R.id.dlg_title)).setText(R.string.closing_app);
		((ImageView) dialog.findViewById(R.id.dlg_icon)).setImageResource(R.drawable.ic_exit);

		final TextView message = (TextView) dialog.findViewById(R.id.message);
		message.setText(R.string.closing_app_message);

		final Button btnNo = (Button) dialog.findViewById(R.id.btn_no);
		btnNo.setOnClickListener(new View.OnClickListener() {
			public void onClick(View v) {
				dialog.dismiss();
			}
		});

		final Button btnYes = (Button) dialog.findViewById(R.id.btn_yes);
		btnYes.setOnClickListener(new View.OnClickListener() {
			public void onClick(View v) {
				dialog.dismiss();
				activity.closeApp();
			}
		});

		return dialog;
	}

	public static Dialog ExitApplication( final EM4058 activity )
	{
		final Dialog dialog = new Dialog( activity );
		dialog.requestWindowFeature( Window.FEATURE_NO_TITLE );
		dialog.setCanceledOnTouchOutside( false );
		dialog.setContentView( R.layout.dialog_yes_no );
		if ( dialog.getWindow() != null )
		{
			dialog.getWindow().setBackgroundDrawable( new ColorDrawable( Color.TRANSPARENT ) );
		}
		((TextView) dialog.findViewById( R.id.dlg_title )).setText( R.string.closing_app );
		((ImageView) dialog.findViewById( R.id.dlg_icon )).setImageResource( R.drawable.ic_exit );

		final TextView message = dialog.findViewById( R.id.message );
		message.setText( R.string.closing_app_message );

		dialog.findViewById( R.id.btn_close_dlg ).setOnClickListener( v -> dialog.dismiss() );
		dialog.findViewById( R.id.btn_no ).setOnClickListener( v -> dialog.dismiss() );

		dialog.findViewById( R.id.btn_yes ).setOnClickListener( v ->
		{
			dialog.dismiss();
			activity.closeApp();
		} );

		return dialog;
	}
	
	
	private static Dialog getDialog(final Activity activity, int layout, int icon, int title){
		final Dialog dialog = new Dialog(activity);		
		dialog.requestWindowFeature(Window.FEATURE_NO_TITLE);		
		dialog.setContentView(layout);
		dialog.setCanceledOnTouchOutside(false);
		dialog.getWindow().getAttributes().width = android.view.ViewGroup.LayoutParams.WRAP_CONTENT;
		dialog.getWindow().getAttributes().height = android.view.ViewGroup.LayoutParams.WRAP_CONTENT;
		((TextView) dialog.findViewById(R.id.dlg_title)).setText(title);
		((ImageView) dialog.findViewById(R.id.dlg_icon)).setImageResource(icon);
		
		dialog.setOnCancelListener(new DialogInterface.OnCancelListener() {  // OnBackPressed            
            public void onCancel(DialogInterface dialog) {
            	dialog.dismiss();            	
            }
        });
		
		return dialog;
	}
	
}
