package com.megabras.bluelogg.extended;

import java.util.Observable;

public class StringObservable extends Observable
{
    public final int ID;
    private String string;

    public StringObservable(int id)
    {
        this.ID = id;
    }

    public StringObservable(int id, String string)
    {
        this.ID = id;
        this.string = string;
    }

    public void set(String string)
    {
        if ( !this.string.equals(string) )
        {
            this.string = string;
            setChanged();
            notifyObservers();
        }
    }

    public void update(String string)
    {
        this.string = string;
        setChanged();
        notifyObservers();
    }

    public String get()
    {
        return this.string;
    }
}
