package com.megabras.bluelogg.md10kvx;

import android.content.Context;
import android.database.sqlite.SQLiteDatabase;
import android.database.sqlite.SQLiteOpenHelper;
import android.provider.BaseColumns;

public final class Database
{

    /* Inner class that defines the table contents */
	static abstract class DatabaseEntry implements BaseColumns
	{
		// If you change the database schema, you must increment the database version.
		static final int DATABASE_VERSION = 1;
		static final String DATABASE_NAME = "DbApplication.db";
		//static final String TABLE_MD10KVx = "MD10KVx_REGISTERS";
		//FIELDS
		static final String DESCRIPTION = "DESCRIPTION";
		static final String COL_A = "COL_A";
		static final String COL_B = "COL_B";
		static final String COL_C = "COL_C";
		static final String COL_D = "COL_D";
	}

	public static abstract class DatabaseDescriptions
	{
		public static final String MODEL = "MODEL";
		public static final String SERIAL = "SERIAL";
		public static final String DATE = "DATE";
		public static final String TEST_NUMBER = "TEST_NUMBER";
		public static final String DAI = "DAI";
		public static final String PI = "PI";
		public static final String SVT = "SVT";
		static final String CAPACITANCE = "CAPACITANCE";
		public static final String RESULT = "RESULT";
		static final String GPS_LATITUDE = "GPS_LATITUDE";
		static final String GPS_LONGITUDE = "GPS_LONGITUDE";
		static final String GPS_ALTITUDE = "GPS_ALTITUDE";
		public static final String GPS_ACCURACY = "GPS_ACCURACY";
	}
    
    public class DbHelper extends SQLiteOpenHelper {    	
    	private static final String TEXT_TYPE = " TEXT";
    	private static final String COMMA_SEP = ",";
    	private static final String FIELD_ENTRIES = 
    			//DatabaseEntry._ID + " INTEGER PRIMARY KEY," +    	    
	    	    DatabaseEntry.DESCRIPTION + TEXT_TYPE + COMMA_SEP +
	    		DatabaseEntry.COL_A + TEXT_TYPE + COMMA_SEP +
	    		DatabaseEntry.COL_B + TEXT_TYPE + COMMA_SEP +
	    	  	DatabaseEntry.COL_C + TEXT_TYPE + COMMA_SEP +	    	  	
	    	  	DatabaseEntry.COL_D + TEXT_TYPE;

//		public static final String SQL_CREATE_ENTRIES = "CREATE TABLE " + DatabaseEntry.TABLE_MD10KVx + " (" + FIELD_ENTRIES + " )";
//		private static final String SQL_DELETE_ENTRIES = "DROP TABLE IF EXISTS " + DatabaseEntry.TABLE_MD10KVx;

		DbHelper( Context context )
		{
			super( context, DatabaseEntry.DATABASE_NAME, null, DatabaseEntry.DATABASE_VERSION );
		}

		void createTable( SQLiteDatabase db, String name )
		{
			String SQL_CREATE_TABLE = "CREATE TABLE " + name + " (" + FIELD_ENTRIES + " )";
			db.execSQL( SQL_CREATE_TABLE );
		}

		public void deleteTable( SQLiteDatabase db, String name )
		{
			String SQL_DELETE_TABLE =
					"DROP TABLE IF EXISTS " + name;
			db.execSQL( SQL_DELETE_TABLE );
		}

		@Override
		public void onCreate( SQLiteDatabase db )
		{
			//db.execSQL(SQL_CREATE_ENTRIES);
		}

		@Override
		public void onUpgrade( SQLiteDatabase db, int oldVersion, int newVersion )
		{
			//db.execSQL(SQL_DELETE_ENTRIES);
			//onCreate(db);
		}

		public void onDowngrade( SQLiteDatabase db, int oldVersion, int newVersion )
		{
			//onUpgrade(db, oldVersion, newVersion);
		}
    }
    
}
