package com.megabras.bluelogg.md10kvx;

import java.io.IOException;
import java.io.InputStream;
import java.io.OutputStream;

import com.megabras.bluelogg.md10kvx.MD10KVx.mHandler;


import android.bluetooth.BluetoothSocket;
import android.os.Handler;

public class MD10KVxConnectThread extends Thread
{
    private BluetoothSocket mmSocket;
    private InputStream mmInStream;
    private OutputStream mmOutStream;
    private Handler handler;

    void ConnectedThread( BluetoothSocket socket, Handler handler )
    {
        mmSocket = socket;
        this.handler = handler;
        InputStream tmpIn = null;
        OutputStream tmpOut = null;

        try
        {
            tmpIn = socket.getInputStream();
            tmpOut = socket.getOutputStream();
        }
        catch ( IOException ignored )
        {
        }

        mmInStream = tmpIn;
        mmOutStream = tmpOut;
    }

    private String logString = "";

    public void run()
    {
        byte[] buffer = new byte[1024];
        int bytes;

        while ( true )
        {
            try
            {
                bytes = mmInStream.read( buffer );

                String readMessage = new String( buffer, 0, bytes );
                logString += readMessage;
                if ( logString.endsWith( "\r\n" ) )
                {
                    android.util.Log.e( "RX>", logString.replace( "\r\n", "" ) );
                    logString = "";
                }
                handler.obtainMessage( mHandler.MESSAGE_READ, bytes, -1, readMessage ).sendToTarget();
            }
            catch ( IOException e )
            {
                break;
            }
        }
    }

    public void write( byte[] bytes )
    {
        try
        {
            mmOutStream.write( bytes );
        }
        catch ( IOException ignored )
        {
        }
    }

    public boolean isConnected() {
        return mmSocket.isConnected();
    }

    public void cancel() {
        try {
            mmSocket.close();
        } catch (IOException ignored) { }
    }
}
