package com.megabras.bluelogg.md10kvx;

import java.util.List;
import android.annotation.SuppressLint;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.CheckBox;
import android.widget.TextView;

import com.megabras.bluelogg.extended.FileDetails;
import com.megabras.bluelogg.R;

public class RecordsBaseAdapter extends BaseAdapter
{

    private LayoutInflater
            inflater;

    private int
            selectedIndex = -1;

    private List<FileDetails>
            records;

    private boolean
            enableSelection = false;

    private boolean[]
            checkState;
	    
//    public RecordsBaseAdapter(Context context) {
//        //this.devices = new ArrayList<String>();
//        //this.context = context;
//        inflater = LayoutInflater.from(context);
//    }

    RecordsBaseAdapter( Context context, List<FileDetails> records )
    {
        checkState = new boolean[records.size()];
        this.records = records;
        inflater = LayoutInflater.from( context );
    }

    public int getCount()
    {
        return records.size();
    }

    public FileDetails getItem( int position )
    {
        return records.get( position );
    }

    public long getItemId( int position )
    {
        return position;
    }

    public void clear()
    {
        this.selectedIndex = -1;
        records.clear();
        checkState = new boolean[0];
        notifyDataSetChanged();
    }

    public void setSelectedIndex( int item )
    {
        this.selectedIndex = item;
    }

    public int getSelectedIndex()
    {
        return this.selectedIndex;
    }

    @SuppressWarnings("SameParameterValue")
    void enableSelection( boolean enable )
    {
        enableSelection = enable;
        if ( !enable )
        {
            int len = checkState.length;
            for ( int i = 0; i < len; i++ )
            {
                checkState[i] = false;
            }
        }
        notifyDataSetChanged();
    }

    boolean hasItemChecked()
    {
        for ( boolean aCheckState : checkState )
        {
            if ( aCheckState )
            {
                return true;
            }
        }
        return false;
    }

//    boolean hasItemChecked()
//    {
//        int len = checkState.length;
//        for ( int i = 0; i < len; i++ )
//        {
//            if ( checkState[i] )
//                return true;
//        }
//        return false;
//    }

//    public void updateRecords( List<FileDetails> records )
//    {
//        this.records = records;
//        checkState = new boolean[records.size()];
//        notifyDataSetChanged();
//    }

    boolean isSelected( int position )
    {
        return checkState[position];
    }
    
    @SuppressLint({"ViewHolder", "SetTextI18n"})
    public View getView( int position, View view, ViewGroup parent )
    {
        view = inflater.inflate( R.layout.recorded_item, parent, false );
        final int pos = position;
        CheckBox checkBox = view.findViewById( R.id.selection_erase );
        checkBox.setChecked( checkState[pos] );
        checkBox.setOnCheckedChangeListener( ( buttonView, isChecked ) -> checkState[pos] = isChecked );

        ((TextView) view.findViewById( R.id.header )).setText( records.get( position ).DATE + " " + records.get( position ).TIME );
        ((TextView) view.findViewById( R.id.recorded_index )).setText( "# " + records.get( position ).INDEX );

        String desc = records.get( position ).MODEL + " " + records.get( position ).SERIAL;
        ((TextView) view.findViewById( R.id.recorded_description )).setText( desc );

        if ( enableSelection )
        {
            view.findViewById( R.id.imageArrow ).setVisibility( View.GONE );
            view.findViewById( R.id.selection_erase ).setVisibility( View.VISIBLE );
            view.findViewById( R.id.selection_erase ).setFocusable( true );
        }
        else
        {
            view.findViewById( R.id.imageArrow ).setVisibility( View.VISIBLE );
            view.findViewById( R.id.selection_erase ).setVisibility( View.GONE );
            view.findViewById( R.id.selection_erase ).setFocusable( false );
        }

        return view;
    }
}
