package com.megabras.bluelogg.md10kvx;

import java.util.ArrayList;
import java.util.List;
import android.content.Context;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.BaseAdapter;
import android.widget.TextView;

import com.megabras.bluelogg.R;
import com.megabras.bluelogg.extended.TableValues;


public class TableBaseAdapter extends BaseAdapter {	
	private LayoutInflater inflater;
	private boolean hideVoltage = false;
	private List<TableValues> tableValues;
	    
    public TableBaseAdapter(Context context) {
    	//values = new String[4];
    	tableValues = new ArrayList<>();
        inflater = LayoutInflater.from(context);
    }

	public void hideVoltage(boolean hide){
		hideVoltage = hide;
	}
    
    public long getItemId(int position) {
		return 0;
	}

    public int getCount() {
        return tableValues.size();
    }

	public void clear()
	{
		tableValues.clear();
	}

	public void remove(int position)
	{
		tableValues.remove(position);
	}
	 
    public TableValues getItem(int position) {
        return tableValues.get(position);
    }
    
    public void addAll(List<TableValues> tableValues){
    	this.tableValues = tableValues; 
    	notifyDataSetChanged();
    }
    
    public void add(String time, String resistance, String voltage, String current){
    	tableValues.add( new TableValues(time, resistance, voltage, current) );
    	//notifyDataSetChanged();
    }

	public void add(String time, String resistance, String current){
		tableValues.add( new TableValues(time, resistance, current) );
		//notifyDataSetChanged();
	}
    
    public void repaint(){
    	notifyDataSetChanged();
    }
       
    public View getView(int position, View view, ViewGroup parent) {    	
    	View vi = view;
    	ViewHolder holder = null;

    	if (vi == null) {
	        vi = inflater.inflate( R.layout.table_item, parent, false);

	        holder = new ViewHolder();
	        holder.col_a = 
	        		(TextView) vi.findViewById(R.id.col_a);
	        holder.col_b = 
	        		(TextView) vi.findViewById(R.id.col_b);
	        holder.col_c = 
	        		(TextView) vi.findViewById(R.id.col_c);
	        holder.col_d = 
	        		(TextView) vi.findViewById(R.id.col_d);
	        vi.setTag(holder);
	    } else {	        
	        holder = (ViewHolder) vi.getTag();
	    }
    	
    	holder.col_a.setText( tableValues.get(position).getTime() );
    	holder.col_b.setText( tableValues.get(position).getResistance() );
		if(hideVoltage)
			holder.col_c.setVisibility(View.GONE);
		else{
			holder.col_c.setText( tableValues.get(position).getVoltage() );
		}
    	holder.col_d.setText( tableValues.get(position).getCurrent() );

        return vi;
    }
    
    static class ViewHolder{
    	TextView col_a;
    	TextView col_b;
    	TextView col_c;
    	TextView col_d;
  	}
    
    
}
