package com.megabras.bluelogg.tm25r;

import android.content.Context;
import android.os.Bundle;
//import android.support.v4.app.Fragment;
import android.util.Log;
import android.view.LayoutInflater;
import android.view.View;
import android.view.ViewGroup;
import android.widget.LinearLayout;
import android.widget.TextView;

import com.megabras.bluelogg.R;
import com.megabras.modbus.TM25R.Device;
import com.megabras.modbus.TM25R.FormatData;
import com.megabras.modbus.TM25R.Measurement;
import com.megabras.modbus.TM25R.Protocol;

import java.util.Observable;
import java.util.Observer;

import androidx.fragment.app.Fragment;


//public class MainScreen extends Fragment implements Observer {
public class MainScreen extends Fragment {
    @SuppressWarnings("unused")
    private final String
            TAG             = "MainScreen";

    public int
            layoutID        =  R.layout.tm25r_fgr_main;

    private Context
            context;

    private View
            view;

    private TextView
            tv_number,
            tv_mode,
            tv_resistance,
            tv_resistanceC,
            tv_capacitance,
            tv_inductance,
            tv_site_name,
            tv_object;

    private String
            testNumber = " - - - ";

    @Override
    public View onCreateView(LayoutInflater inflater, ViewGroup container, Bundle savedInstanceState) {
        context = inflater.getContext();
        view = inflater.inflate(layoutID, container, false);
        view.setBackgroundColor(context.getResources().getColor(R.color.transparent));
        return view;
    }

    @Override
    public void onStart() {
        super.onStart();
        if (this.getView()==null)
            return;
        tv_number       = this.getView().findViewById(R.id.tv_number);
        tv_mode         = this.getView().findViewById(R.id.tv_mode);
        tv_resistance   = this.getView().findViewById(R.id.tv_resistance);
        tv_resistanceC  = this.getView().findViewById(R.id.tv_resistanceC);
        tv_capacitance  = this.getView().findViewById(R.id.tv_capacitance);
        tv_inductance   = this.getView().findViewById(R.id.tv_inductance);
        tv_site_name    = this.getView().findViewById(R.id.tv_site_name);
        tv_object       = this.getView().findViewById(R.id.tv_object);
    }

    public void setTestNumber(int number)
    {
        if(number<=0)
            testNumber = " - - - ";
        else
            testNumber = number +"";
        tv_number.setText( testNumber );
    }

    public void setMode(int mode)
    {
        String m;
        if (mode== Protocol.MODE_COMPENSATION)
            m = context.getString(R.string.compensation_mode);
        else
            m = context.getString(R.string.normal_mode);
        tv_mode.setText( m );
        tv_number.setText(" - - - ");
        tv_resistance.setText(" - - - ");
        tv_resistanceC.setText(" - - - ");
        tv_capacitance.setText(" - - - ");
        tv_inductance.setText(" - - - ");
    }

    public void setTestSite(String siteName)
    {
        tv_site_name.setText(siteName);
    }

    public void setObject(String objectName)
    {
        tv_object.setText(objectName);
    }



    public void resetObject()
    {
        try
        {
            tv_object.setText(" - - - ");
        }
        catch (Exception ignored){}
    }

    public void reset()
    {
        try
        {
            tv_number.setText(" - - - ");
            tv_mode.setText(" - - - ");
            tv_resistance.setText(" - - - ");
            tv_resistanceC.setText(" - - - ");
            tv_capacitance.setText(" - - - ");
            tv_inductance.setText(" - - - ");
            tv_site_name.setText(" - - - ");
            tv_object.setText(" - - - ");
        }
        catch (Exception ignored){}
    }

    public void resetMeasurement()
    {
        try
        {
            tv_number.setText(" - - - ");
            tv_resistance.setText(" - - - ");
            tv_resistanceC.setText(" - - - ");
            tv_capacitance.setText(" - - - ");
            tv_inductance.setText(" - - - ");
        }
        catch (Exception ignored){}
    }

    public void update(Device device, Measurement m)
    {
        if ( this.getView()==null )
            return;

        tv_number.setText(m.getTestNumber() + "");
        tv_resistance.setText((m.getResistance()));

        if (device.getMode()==Protocol.MODE_COMPENSATION) {
            tv_resistanceC.setText((m.getResistanceCompensated()));
            tv_capacitance.setText((m.getCapacitance()));
            tv_inductance.setText((m.getInductance()));
        }
        else{
            tv_resistanceC.setText(" - - - ");
            tv_capacitance.setText(" - - - ");
            tv_inductance.setText(" - - - ");
        }
    }

//    @Override
//    public void update(Observable o, Object arg) {
//        if ( this.getView()==null )
//            return;
//        if (o instanceof Measurement)
//        {
//            Measurement m = (Measurement) o;
//            int itemID    = (int) arg;
//            switch (itemID){
//                case Measurement.ID_RESET:
//                    tv_number.setText(" - - - ");
//                    tv_resistance.setText(" - - - ");
//                    tv_resistanceC.setText(" - - - ");
//                    tv_capacitance.setText(" - - - ");
//                    tv_inductance.setText(" - - - ");
//                    break;
//                case Measurement.ID_TEST_NUMBER:
//                    tv_number.setText(m.getTestNumber());
//                    break;
//                case Measurement.ID_RESISTANCE:
//                    tv_resistance.setText(m.getResistance());
//                    break;
//                case Measurement.ID_RESISTANCE_C:
//                    tv_resistanceC.setText(m.getResistanceCompensated());
//                    break;
//                case Measurement.ID_CAPACITANCE:
//                    tv_capacitance.setText(m.getCapacitance());
//                    break;
//                case Measurement.ID_INDUCTANCE:
//                    tv_inductance.setText(m.getInductance());
//                    break;
//            }
//        }
//    }
}

