package com.megabras.bluelogg.tm25r;

import android.content.Context;
import android.content.res.Configuration;
import android.graphics.drawable.Drawable;
//import android.support.v4.app.Fragment;
//import android.support.v4.app.FragmentManager;
//import android.support.v4.app.FragmentStatePagerAdapter;
import android.text.Spannable;
import android.text.SpannableString;
import android.text.style.ImageSpan;

import com.megabras.bluelogg.R;

import java.util.ArrayList;

import androidx.fragment.app.Fragment;
import androidx.fragment.app.FragmentManager;
import androidx.fragment.app.FragmentStatePagerAdapter;

public class PagerAdapter extends FragmentStatePagerAdapter {
    private final String
            TAG = "PagerAdapter";

    private Context
            context;

    private int
            numPages = 2;

    private MainScreen
            mainScreen;

    private Table
            table;

    private ArrayList<Fragment>
            fragments = new ArrayList<>();

    public PagerAdapter(FragmentManager fm, Context context) {
        super(fm);
        this.context = context;

        boolean isTablet = context.getResources().getBoolean(R.bool.isTablet);

        if (isTablet)
            numPages = 1;

        mainScreen  = new MainScreen();
        table       = new Table();
        table.setChartType( Table.TABLE, "" );
    }

    public void addFragment(Fragment frag){
        fragments.add(frag);
    }

//    @Override
//    public Fragment getItem(int i) {
//        switch (i) {
//            case 0:
//                return mainScreen;
//            case 1:
//                return table;
//        }
//        return null;
//    }


//    @Override
//    public int getCount(){
//        return numPages;
//    }

    @Override
    public Fragment getItem(int i) {
        return fragments.get(i);
    }

    @Override
    public int getCount(){
        return fragments.size();
    }

    public MainScreen getMainFragment(){ return mainScreen; }

    public Table table(){
        return table;
    }

    private int[] imageResId = {
            R.drawable.ic_analog,
            R.drawable.ic_table
    };

    private int[] imageResIdSmall = {
            R.drawable.ic_analog_20,
            R.drawable.ic_table_20
    };

    @Override
    public CharSequence getPageTitle(int position) {
        int[] images;
        if(screenSizeIsLarge(context)) {
            images = imageResId;
        } else {
            images = imageResIdSmall;
        }
        Drawable image      = context.getResources().getDrawable(images[position]);
        image.setBounds(0, 0, image.getIntrinsicWidth(), image.getIntrinsicHeight());
        SpannableString sb  = new SpannableString(" ");
        ImageSpan imageSpan = new ImageSpan(image, ImageSpan.ALIGN_BOTTOM);
        sb.setSpan(imageSpan, 0, 1, Spannable.SPAN_EXCLUSIVE_EXCLUSIVE);
        return sb;
    }

    private boolean screenSizeIsLarge(Context context){
        return (context.getResources().getConfiguration().screenLayout &
                Configuration.SCREENLAYOUT_SIZE_MASK) == Configuration.SCREENLAYOUT_SIZE_LARGE;
    }

}



